SIP Refer a call
Initiate a SIP Refer on a Call Control call. You can initiate a SIP Refer at any point in the duration of a call.
Expected Webhooks:
call.refer.startedcall.refer.completedcall.refer.failed
import Telnyx from 'telnyx';
const client = new Telnyx({
apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
});
const response = await client.calls.actions.refer('call_control_id', {
sip_address: 'sip:[email protected]',
});
console.log(response.data);import os
from telnyx import Telnyx
client = Telnyx(
api_key=os.environ.get("TELNYX_API_KEY"), # This is the default and can be omitted
)
response = client.calls.actions.refer(
call_control_id="call_control_id",
sip_address="sip:[email protected]",
)
print(response.data)
package main
import (
"context"
"fmt"
"github.com/team-telnyx/telnyx-go"
"github.com/team-telnyx/telnyx-go/option"
)
func main() {
client := telnyx.NewClient(
option.WithAPIKey("My API Key"),
)
response, err := client.Calls.Actions.Refer(
context.TODO(),
"call_control_id",
telnyx.CallActionReferParams{
SipAddress: "sip:[email protected]",
},
)
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", response.Data)
}
package com.telnyx.sdk.example;
import com.telnyx.sdk.client.TelnyxClient;
import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
import com.telnyx.sdk.models.calls.actions.ActionReferParams;
import com.telnyx.sdk.models.calls.actions.ActionReferResponse;
public final class Main {
private Main() {}
public static void main(String[] args) {
TelnyxClient client = TelnyxOkHttpClient.fromEnv();
ActionReferParams params = ActionReferParams.builder()
.callControlId("call_control_id")
.sipAddress("sip:[email protected]")
.build();
ActionReferResponse response = client.calls().actions().refer(params);
}
}require "telnyx"
telnyx = Telnyx::Client.new(api_key: "My API Key")
response = telnyx.calls.actions.refer("call_control_id", sip_address: "sip:[email protected]")
puts(response)<?php
require_once dirname(__DIR__) . '/vendor/autoload.php';
use Telnyx\Client;
use Telnyx\Core\Exceptions\APIException;
$client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API Key');
try {
$response = $client->calls->actions->refer(
'call_control_id',
sipAddress: 'sip:[email protected]',
clientState: 'aGF2ZSBhIG5pY2UgZGF5ID1d',
commandID: '891510ac-f3e4-11e8-af5b-de00688a4901',
customHeaders: [
['name' => 'head_1', 'value' => 'val_1'],
['name' => 'head_2', 'value' => 'val_2'],
],
sipAuthPassword: 'sip_auth_password',
sipAuthUsername: 'sip_auth_username',
sipHeaders: [['name' => 'User-to-User', 'value' => 'value']],
);
var_dump($response);
} catch (APIException $e) {
echo $e->getMessage();
}telnyx calls:actions refer \
--api-key 'My API Key' \
--call-control-id call_control_id \
--sip-address sip:[email protected]curl --request POST \
--url https://api.telnyx.com/v2/calls/{call_control_id}/actions/refer \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"sip_address": "sip:[email protected]"
}
'{
"data": {
"result": "ok"
}
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Path Parameters
Unique identifier and token for controlling the call
Body
Refer request
The SIP URI to which the call will be referred to.
"sip:[email protected]"
Use this field to add state to every subsequent webhook. It must be a valid Base-64 encoded string.
"aGF2ZSBhIG5pY2UgZGF5ID1d"
Use this field to avoid execution of duplicate commands. Telnyx will ignore subsequent commands with the same command_id as one that has already been executed.
"891510ac-f3e4-11e8-af5b-de00688a4901"
Custom headers to be added to the SIP INVITE.
Show child attributes
Show child attributes
[
{ "name": "head_1", "value": "val_1" },
{ "name": "head_2", "value": "val_2" }
]
SIP Authentication username used for SIP challenges.
SIP Authentication password used for SIP challenges.
SIP headers to be added to the request. Currently only User-to-User header is supported.
Show child attributes
Show child attributes
[
{ "name": "User-to-User", "value": "value" }
]
Response
Successful response upon making a call control command.
Show child attributes
Show child attributes
{ "result": "ok" }
Was this page helpful?
import Telnyx from 'telnyx';
const client = new Telnyx({
apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
});
const response = await client.calls.actions.refer('call_control_id', {
sip_address: 'sip:[email protected]',
});
console.log(response.data);import os
from telnyx import Telnyx
client = Telnyx(
api_key=os.environ.get("TELNYX_API_KEY"), # This is the default and can be omitted
)
response = client.calls.actions.refer(
call_control_id="call_control_id",
sip_address="sip:[email protected]",
)
print(response.data)
package main
import (
"context"
"fmt"
"github.com/team-telnyx/telnyx-go"
"github.com/team-telnyx/telnyx-go/option"
)
func main() {
client := telnyx.NewClient(
option.WithAPIKey("My API Key"),
)
response, err := client.Calls.Actions.Refer(
context.TODO(),
"call_control_id",
telnyx.CallActionReferParams{
SipAddress: "sip:[email protected]",
},
)
if err != nil {
panic(err.Error())
}
fmt.Printf("%+v\n", response.Data)
}
package com.telnyx.sdk.example;
import com.telnyx.sdk.client.TelnyxClient;
import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
import com.telnyx.sdk.models.calls.actions.ActionReferParams;
import com.telnyx.sdk.models.calls.actions.ActionReferResponse;
public final class Main {
private Main() {}
public static void main(String[] args) {
TelnyxClient client = TelnyxOkHttpClient.fromEnv();
ActionReferParams params = ActionReferParams.builder()
.callControlId("call_control_id")
.sipAddress("sip:[email protected]")
.build();
ActionReferResponse response = client.calls().actions().refer(params);
}
}require "telnyx"
telnyx = Telnyx::Client.new(api_key: "My API Key")
response = telnyx.calls.actions.refer("call_control_id", sip_address: "sip:[email protected]")
puts(response)<?php
require_once dirname(__DIR__) . '/vendor/autoload.php';
use Telnyx\Client;
use Telnyx\Core\Exceptions\APIException;
$client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API Key');
try {
$response = $client->calls->actions->refer(
'call_control_id',
sipAddress: 'sip:[email protected]',
clientState: 'aGF2ZSBhIG5pY2UgZGF5ID1d',
commandID: '891510ac-f3e4-11e8-af5b-de00688a4901',
customHeaders: [
['name' => 'head_1', 'value' => 'val_1'],
['name' => 'head_2', 'value' => 'val_2'],
],
sipAuthPassword: 'sip_auth_password',
sipAuthUsername: 'sip_auth_username',
sipHeaders: [['name' => 'User-to-User', 'value' => 'value']],
);
var_dump($response);
} catch (APIException $e) {
echo $e->getMessage();
}telnyx calls:actions refer \
--api-key 'My API Key' \
--call-control-id call_control_id \
--sip-address sip:[email protected]curl --request POST \
--url https://api.telnyx.com/v2/calls/{call_control_id}/actions/refer \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"sip_address": "sip:[email protected]"
}
'{
"data": {
"result": "ok"
}
}